
#ifndef __Mod_GScript_Variable__
#define __Mod_GScript_Variable__

//---- ϐǗW[
#define global GSMD_VARIABLE_TYPE_NULL		0
#define global GSMD_VARIABLE_TYPE_LABEL		1
#define global GSMD_VARIABLE_TYPE_STR		2
#define global GSMD_VARIABLE_TYPE_DOUBLE	3
#define global GSMD_VARIABLE_TYPE_INT		4

#define global GSMD_VARIABLE_ATTRIB_SYSTEM	1

#module mod_gs_variable \
	id, \
	name, \
	refcount, \
	attrib, \
	type, \
	size, \
	data, \
	maxlen, \
	len1, \
	len2, \
	len3, \
	len4

	#modinit
		mod_GetID id
		refcount	= 0
		attrib	= 0
		type	= GSMD_VARIABLE_TYPE_NULL
		size	= 0
		dim data, 1, 1, 1, 1
		len1	= 1
		len2	= 1
		len3	= 1
		len4	= 1
		maxlen	= 1
		return id

	#define global gs_variable_addref(%1)		_gs_variable_addref Gmd_Variable_Container@ModGS_Variable(%1)
	#modfunc _gs_variable_addref
		refcount++
		return
	#define global gs_variable_release(%1)		_gs_variable_release Gmd_Variable_Container@ModGS_Variable(%1)
	#modfunc _gs_variable_release
		refcount--
		return
	#define global ctype gs_variable_get_refcount(%1)		_gs_variable_get_refcount(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_refcount
		return refcount

	#define global gs_variable_construct(%1,%2,%3,%4,%5,%6,%7,%8)		_gs_variable_construct Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7,%8
	#modfunc _gs_variable_construct str var_name, int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		name	= var_name
		type	= var_type
		size	= var_size : if (size < 4) : size = 4
		len1	= var_len1 : if (len1 < 1) : len1 = 1
		len2	= var_len2 : if (len2 < 1) : len2 = 1
		len3	= var_len3 : if (len3 < 1) : len3 = 1
		len4	= var_len4 : if (len4 < 1) : len4 = 1
		maxlen	= len1 * len2 * len3 * len4
		if (type >= 2) && (type <= 4) : dimtype data, type, len1, len2, len3, len4
		if (type == 1) : dim data, len1, len2, len3, len4
		return

	#define global gs_variable_reconstruct(%1,%2,%3,%4,%5,%6,%7)		_gs_variable_reconstruct Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_reconstruct int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		type	= var_type
		size	= var_size : if (size < 4) : size = 4
		len1	= var_len1 : if (len1 < 1) : len1 = 1
		len2	= var_len2 : if (len2 < 1) : len2 = 1
		len3	= var_len3 : if (len3 < 1) : len3 = 1
		len4	= var_len4 : if (len4 < 1) : len4 = 1
		maxlen	= len1 * len2 * len3 * len4
		if (type >= 2) && (type <= 4) : dimtype data, type, len1, len2, len3, len4
		if (type == 1) : dim data, len1, len2, len3, len4
		return

	#define	global ctype gs_variable_get_name(%1=0)		_gs_variable_get_name(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_name
		return name

	#define	global ctype gs_variable_get_attrib(%1=0)	_gs_variable_get_attrib(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_attrib
		return attrib

	#define	global ctype gs_variable_get_type(%1=0)		_gs_variable_get_type(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_type
		return type

	#define	global ctype gs_variable_get_size(%1=0)		_gs_variable_get_size(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_size
		return size

	#define	global gs_variable_set_attrib(%1=0,%2=0)	_gs_variable_set_attrib Gmd_Variable_Container@ModGS_Variable(%1),%2
	#modfunc _gs_variable_set_attrib int p0
		attrib = p0
		return 

	#define	global ctype gs_variable_get_array(%1=0)	_gs_variable_get_array(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_array
		return maxlen

	#define	global ctype gs_variable_get_len1(%1=0)		_gs_variable_get_len1(Gmd_Variable_Container@ModGS_Variable(%1))
	#define	global ctype gs_variable_get_len2(%1=0)		_gs_variable_get_len2(Gmd_Variable_Container@ModGS_Variable(%1))
	#define	global ctype gs_variable_get_len3(%1=0)		_gs_variable_get_len3(Gmd_Variable_Container@ModGS_Variable(%1))
	#define	global ctype gs_variable_get_len4(%1=0)		_gs_variable_get_len4(Gmd_Variable_Container@ModGS_Variable(%1))

	#modcfunc _gs_variable_get_len1
		return len1
	#modcfunc _gs_variable_get_len2
		return len2
	#modcfunc _gs_variable_get_len3
		return len3
	#modcfunc _gs_variable_get_len4
		return len4


//	typename

	#defcfunc _gs_variable_typename int p_type
		if p_type == 0 : return "NULL"
		if p_type == 1 : return "LABEL"
		if p_type == 2 : return "STR"
		if p_type == 3 : return "DOUBLE"
		if p_type == 4 : return "INT"
		return "UNKNOWN"

//	debug

#if GSMD_DEBUG
	#modcfunc _gs_variable_info
		if (attrib & GSMD_VARIABLE_ATTRIB_SYSTEM) {
			return "id="+id+"\t(sysvar)\t"+name+"\t("+len1+","+len2+","+len3+","+len4+")\t"+_gs_variable_typename(type)+"\t"+data
		} else {
			return "id="+id+"\t(ref="+refcount+")\t"+name+"\t("+len1+","+len2+","+len3+","+len4+")\t"+_gs_variable_typename(type)+"\t"+data
		}
		return "id="+id+" "+name+" unknown"
#endif

//	error macro

	#modfunc _gs_variable_error int p_error, int p_prm1, int p_prm2, int p_prm3, int p_prm4
		_gsc_error = -3
		_gsc_error_info = "Variable: "
		;_gsc_error_section = GSMD_SECTION_VARIABLE
#if GSMD_ERROR_DETAIL = 2
		if p_error == -1 : _gsc_error_info += "Array index out of range.\n"+name+"("+p_prm1+","+p_prm2+","+p_prm3+","+p_prm4+")\nlength("+(len1-1)+","+(len2-1)+","+(len3-1)+","+(len4-1)+")" : return
		if p_error == -2 : _gsc_error_info += "A requested assignment is not supported by this variable/value type.\n"+name+" ("+_gs_variable_typename(type)+")" : return
		if p_error == -3 : _gsc_error_info += "Assigned to different type of array.\n"+name+" ("+_gs_variable_typename(type)+")" : return
		if p_error == -4 : _gsc_error_info += "Divide by 0.\n"+name+" ("+_gs_variable_typename(type)+")" : return
#endif
		return

	//	zvfw͈̔͊mF
	#define error_check_ArrayIndex(%1,%2,%3,%4,%5=-1) if ((len1<=%1)||(len2<=%2)||(len3<=%3)||(len4<=%4))||((%1<0)||(%2<0)||(%3<0)||(%4<0)){\
	_gs_variable_error thismod,-1,%1,%2,%3,%4 :return %5}

	//	Ώەϐ̖^Cv`FbNiw肳ꂽ^CvȂ΃G[j
	#define error_check_InvalidVariableType(%1,%2) if(%1 == %2) {\
	_gs_variable_error thismod,-2,0,0,0,0 :return -1}

	//	Ώەϐ̖^Cv`FbN2wiw肳ꂽ^CvȂ΃G[j
	#define error_check_InvalidVariableType2(%1,%2,%3) if(%1 == %2) || (%1 == %3) {\
	_gs_variable_error thismod,-2,0,0,0,0 :return -1}

	//	Ώەϐƒl̖^Cv`FbNiw肳ꂽ^CvȂ΃G[j
	#define error_check_InvalidType(%1,%2,%3) if(%1 == %3) || (%2 == %3) {\
	_gs_variable_error thismod,-2,0,0,0,0 :return -1}

	//	Ώەϐƒl̗L^Cv`FbNiw肳ꂽ^CvłȂ΃G[j
	#define error_check_RequireType(%1,%2,%3) if(%1 != %3) || (%2 != %3) {\
	_gs_variable_error thismod,-2,0,0,0,0 :return -1}

	//	Ώەϐ̗L^Cv`FbNiw肳ꂽ^CvłȂ΃G[j
	#define error_check_RequireVariableType(%1,%2) if(%1 != %2) {\
	_gs_variable_error thismod,-2,0,0,0,0 :return -1}

	//	G[AZqϐl̃^CvT|[gĂȂ
	#define error_NotSupportedType	_gs_variable_error thismod,-2,0,0,0,0

	//	G[AقȂ^̔zɑ
	#define error_DifferentTypeOfArray	_gs_variable_error thismod,-3,0,0,0,0

	//	Z̒l`FbNAi[Zj
	#define error_check_DivValue(%1) if(%1 == 0) {\
	_gs_variable_error thismod,-4,0,0,0,0 :return -1}



//	variable

	#define	global ctype gs_variable_get_value(%1=0)		_gs_variable_get_value(Gmd_Variable_Container@ModGS_Variable(%1))
	#modcfunc _gs_variable_get_value
		return data

	#define	global gs_variable_increment(%1=0)		_gs_variable_increment Gmd_Variable_Container@ModGS_Variable(%1)
	#modfunc _gs_variable_increment
		;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_LABEL
		data++
		return 0

	#define	global gs_variable_decrement(%1=0)		_gs_variable_decrement Gmd_Variable_Container@ModGS_Variable(%1)
	#modfunc _gs_variable_decrement
		;if (type == GSMD_VARIABLE_TYPE_STR) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidVariableType2 type, GSMD_VARIABLE_TYPE_STR, GSMD_VARIABLE_TYPE_LABEL
		data--
		return 0

	#define global gs_variable_write_reset(%1=0)		_gs_variable_write_reset Gmd_Variable_Container@ModGS_Variable(%1)
	#modfunc _gs_variable_write_reset
		if (type == GSMD_VARIABLE_TYPE_INT) : data = 0 : return 0
		if (type == GSMD_VARIABLE_TYPE_STR) : data = "" : return 0
		if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data = 0.0 : return 0
		if (type == GSMD_VARIABLE_TYPE_LABEL) : data = 0 : return 0
		return 0

	#define	global gs_variable_write(%1=0,%2,%3)		_gs_variable_write Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_write var var_data, var var_type
		if var_type != type {
			if (maxlen > 1) {
				if (type == GSMD_VARIABLE_TYPE_INT) : data = int(var_data) : return 0
				if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data = double(var_data) : return 0
				if (type == GSMD_VARIABLE_TYPE_STR) : data = str(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
				error_DifferentTypeOfArray
				return -1
			}
			;type = var_type
			_gs_variable_reconstruct thismod, var_type, 4, 1, 1, 1, 1
		}
		data = var_data
		return 0

	#define	global gs_variable_write_int(%1=0,%2=0)		_gs_variable_write_int Gmd_Variable_Container@ModGS_Variable(%1),%2
	#modfunc _gs_variable_write_int int var_data
		if (type != GSMD_VARIABLE_TYPE_INT) {
			if (maxlen > 1) {
				if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data = double(var_data) : return 0
				if (type == GSMD_VARIABLE_TYPE_STR) : data = str(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
				error_DifferentTypeOfArray
				return -1
			}
			type = GSMD_VARIABLE_TYPE_INT
			dim data, 1, 1, 1, 1
		}
		data = var_data
		return 0

	#define	global gs_variable_write_double(%1=0,%2=0.0)		_gs_variable_write_double Gmd_Variable_Container@ModGS_Variable(%1),%2
	#modfunc _gs_variable_write_double double var_data
		if (type != GSMD_VARIABLE_TYPE_DOUBLE) {
			if (maxlen > 1) {
				if (type == GSMD_VARIABLE_TYPE_INT) : data = int(var_data) : return 0
				if (type == GSMD_VARIABLE_TYPE_STR) : data = str(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
				error_DifferentTypeOfArray
				return -1
			}
			type = GSMD_VARIABLE_TYPE_DOUBLE
			ddim data, 1, 1, 1, 1
		}
		data = var_data
		return 0

	#define	global gs_variable_write_str(%1=0,%2="")		_gs_variable_write_str Gmd_Variable_Container@ModGS_Variable(%1),%2
	#modfunc _gs_variable_write_str str var_data
		if (type != GSMD_VARIABLE_TYPE_STR) {
			if (maxlen > 1) {
				if (type == GSMD_VARIABLE_TYPE_INT) : data = int(var_data) : return 0
				if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data = double(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
				error_DifferentTypeOfArray
				return -1
			}
			type = GSMD_VARIABLE_TYPE_STR
			sdim data, 1, 1, 1, 1, 1
		}
		data = var_data
		return 0

	#define	global gs_variable_write_label(%1=0,%2=0)		_gs_variable_write_label Gmd_Variable_Container@ModGS_Variable(%1),%2
	#modfunc _gs_variable_write_label int var_data
		if (type != GSMD_VARIABLE_TYPE_LABEL) {
			if (maxlen > 1) {
				;if (type == GSMD_VARIABLE_TYPE_INT) : data = int(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data = double(var_data) : return 0
				;if (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
				error_DifferentTypeOfArray
				return -1
			}
			type = GSMD_VARIABLE_TYPE_LABEL
			dim data, 1, 1, 1, 1
		}
		data = var_data
		return 0

	#define	global gs_variable_operation_add(%1=0,%2,%3)		_gs_variable_operation_add Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_add var var_data, var var_type
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type == GSMD_VARIABLE_TYPE_INT) : data += int(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data += double(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_STR) : data += str(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data += var_data
		return 0

	#define	global gs_variable_operation_sub(%1=0,%2,%3)		_gs_variable_operation_sub Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_sub var var_data, var var_type
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		if (var_type != type) {
			if (type == GSMD_VARIABLE_TYPE_INT) : data -= int(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data -= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data -= var_data
		return 0

	#define	global gs_variable_operation_mul(%1=0,%2,%3)		_gs_variable_operation_mul Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_mul var var_data, var var_type
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		if (var_type != type) {
			if (type == GSMD_VARIABLE_TYPE_INT) : data *= int(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data *= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data *= var_data
		return 0

	#define	global gs_variable_operation_div(%1=0,%2,%3)		_gs_variable_operation_div Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_div var var_data, var var_type
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_data == 0) : return -4
		error_check_DivValue var_data
		if (var_type != type) {
			if (type == GSMD_VARIABLE_TYPE_INT) : data /= int(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data /= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data /= var_data
		return 0

	#define	global gs_variable_operation_mod(%1=0,%2,%3)		_gs_variable_operation_mod Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_mod var var_data, var var_type
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_data == 0) : return -4
		error_check_DivValue var_data
		if var_type != type {
			if (type == GSMD_VARIABLE_TYPE_INT) : data \= int(var_data) : return 0
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data \= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data \= var_data
		return 0

	#define	global gs_variable_operation_and(%1=0,%2,%3)		_gs_variable_operation_and Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_and var var_data, var var_type
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data &= var_data
		return 0

	#define	global gs_variable_operation_or(%1=0,%2,%3)		_gs_variable_operation_or Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_or var var_data, var var_type
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data |= var_data
		return 0

	#define	global gs_variable_operation_xor(%1=0,%2,%3)		_gs_variable_operation_xor Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_xor var var_data, var var_type
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data ^= var_data
		return 0

	#define	global gs_variable_operation_shl(%1=0,%2,%3)		_gs_variable_operation_shl Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_shl var var_data, var var_type
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data <<= var_data
		return 0

	#define	global gs_variable_operation_shr(%1=0,%2,%3)		_gs_variable_operation_shr Gmd_Variable_Container@ModGS_Variable(%1),%2,%3
	#modfunc _gs_variable_operation_shr var var_data, var var_type
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data >>= var_data
		return 0

// array

	#define	global ctype gs_variable_get_array_value(%1=0,%2=0,%3=0,%4=0,%5=0) _gs_variable_get_array_value(Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5)
	#modcfunc _gs_variable_get_array_value int var_len1, int var_len2, int var_len3, int var_len4
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4, 0	//	͔zG[Ă 0 Ԃ悤ɂ
/*
		if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) {
			if (type == GSMD_VARIABLE_TYPE_INT) : return 0
			if (type == GSMD_VARIABLE_TYPE_STR) : return "error"
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : return 0.0
			if (type == GSMD_VARIABLE_TYPE_LABEL) : return 0
			return 0
		}
		if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) {
			if (type == GSMD_VARIABLE_TYPE_INT) : return 0
			if (type == GSMD_VARIABLE_TYPE_STR) : return "error"
			if (type == GSMD_VARIABLE_TYPE_DOUBLE) : return 0.0
			if (type == GSMD_VARIABLE_TYPE_LABEL) : return 0
			return 0
		}
*/
		return data(var_len1,var_len2,var_len3,var_len4)

	#define global gs_variable_array_increment(%1=0,%2=0,%3=0,%4=0,%5=0)		_gs_variable_array_increment Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5
	#modfunc _gs_variable_array_increment int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		if (type == GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4)++ : return 0
		if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4)+1.0 : return 0
		error_NotSupportedType
		return 0

	#define global gs_variable_array_decrement(%1=0,%2=0,%3=0,%4=0,%5=0)		_gs_variable_array_decrement Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5
	#modfunc _gs_variable_array_decrement int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		if (type == GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4)-- : return 0
		if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4)-1.0 : return 0
		error_NotSupportedType
		return 0

	#define global gs_variable_array_write_reset(%1=0,%2=0,%3=0,%4=0,%5=0)		_gs_variable_array_write_reset Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5
	#modfunc _gs_variable_array_write_reset int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		if (type == GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) = 0 : return 0
		if (type == GSMD_VARIABLE_TYPE_STR) : data(var_len1,var_len2,var_len3,var_len4) = "" : return 0
		if (type == GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) = 0.0 : return 0
		if (type == GSMD_VARIABLE_TYPE_LABEL) : data(var_len1,var_len2,var_len3,var_len4) = 0 : return 0
		error_NotSupportedType
		return 0

	#define	global gs_variable_array_write(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_write Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_write var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if (var_type != type) : return -1
		error_check_RequireVariableType type, var_type
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		data(var_len1,var_len2,var_len3,var_len4) = var_data
		return 0

	#define	global gs_variable_array_write_int(%1=0,%2=0,%3=0,%4=0,%5=0,%6=0)		_gs_variable_array_write_int Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6
	#modfunc _gs_variable_array_write_int int var_data, int var_len1, int var_len2, int var_len3, int var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) : return -1
		error_check_RequireVariableType type, GSMD_VARIABLE_TYPE_INT
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		data(var_len1,var_len2,var_len3,var_len4) = var_data
		return 0

	#define	global gs_variable_array_write_double(%1=0,%2=0.0,%3=0,%4=0,%5=0,%6=0)		_gs_variable_array_write_double Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6
	#modfunc _gs_variable_array_write_double double var_data, int var_len1, int var_len2, int var_len3, int var_len4
		;if (type != GSMD_VARIABLE_TYPE_DOUBLE) : return -1
		error_check_RequireVariableType type, GSMD_VARIABLE_TYPE_DOUBLE
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		data(var_len1,var_len2,var_len3,var_len4) = var_data
		return 0

	#define	global gs_variable_array_write_str(%1=0,%2="",%3=0,%4=0,%5=0,%6=0)		_gs_variable_array_write_str Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6
	#modfunc _gs_variable_array_write_str str var_data, int var_len1, int var_len2, int var_len3, int var_len4
		;if (type != GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_RequireVariableType type, GSMD_VARIABLE_TYPE_STR
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		data(var_len1,var_len2,var_len3,var_len4) = var_data
		return 0

	#define	global gs_variable_array_write_label(%1=0,%2=0,%3=0,%4=0,%5=0,%6=0)		_gs_variable_array_write_label Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6
	#modfunc _gs_variable_array_write_label int var_data, int var_len1, int var_len2, int var_len3, int var_len4
		;if (type != GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_RequireVariableType type, GSMD_VARIABLE_TYPE_LABEL
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		data(var_len1,var_len2,var_len3,var_len4) = var_data
		return 0

	#define	global gs_variable_array_operation_add(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_add Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_add var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type = GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) += int(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) += double(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_STR) : data(var_len1,var_len2,var_len3,var_len4) += str(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data(var_len1,var_len2,var_len3,var_len4) += var_data
		return 0

	#define	global gs_variable_array_operation_sub(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_sub Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_sub var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type = GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) -= int(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) -= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data(var_len1,var_len2,var_len3,var_len4) -= var_data
		return 0

	#define	global gs_variable_array_operation_mul(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_mul Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_mul var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type = GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) *= int(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) *= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data(var_len1,var_len2,var_len3,var_len4) *= var_data
		return 0

	#define	global gs_variable_array_operation_div(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_div Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_div var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (var_data == 0) : return -4
		error_check_DivValue var_data
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type = GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) /= int(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) /= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data(var_len1,var_len2,var_len3,var_len4) /= var_data
		return 0

	#define	global gs_variable_array_operation_mod(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_mod Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_mod var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (var_data == 0) : return -4
		error_check_DivValue var_data
		;if (type == GSMD_VARIABLE_TYPE_STR) : return -1
		error_check_InvalidVariableType type, GSMD_VARIABLE_TYPE_STR
		;if (var_type == GSMD_VARIABLE_TYPE_LABEL) || (type == GSMD_VARIABLE_TYPE_LABEL) : return -1
		error_check_InvalidType type,var_type, GSMD_VARIABLE_TYPE_LABEL
		if (var_type != type) {
			if (type = GSMD_VARIABLE_TYPE_INT) : data(var_len1,var_len2,var_len3,var_len4) \= int(var_data) : return 0
			if (type = GSMD_VARIABLE_TYPE_DOUBLE) : data(var_len1,var_len2,var_len3,var_len4) \= double(var_data) : return 0
			error_DifferentTypeOfArray
			return -1
		}
		data(var_len1,var_len2,var_len3,var_len4) \= var_data
		return 0

	#define	global gs_variable_array_operation_and(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_and Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_and var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data(var_len1,var_len2,var_len3,var_len4) &= var_data
		return 0
	
	#define	global gs_variable_array_operation_or(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_or Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_or var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data(var_len1,var_len2,var_len3,var_len4) |= var_data
		return 0

	#define	global gs_variable_array_operation_xor(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_xor Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_xor var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data(var_len1,var_len2,var_len3,var_len4) ^= var_data
		return 0

	#define	global gs_variable_array_operation_shl(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_shl Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_shl var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data(var_len1,var_len2,var_len3,var_len4) <<= var_data
		return 0

	#define	global gs_variable_array_operation_shr(%1=0,%2,%3,%4=0,%5=0,%6=0,%7=0)		_gs_variable_array_operation_shr Gmd_Variable_Container@ModGS_Variable(%1),%2,%3,%4,%5,%6,%7
	#modfunc _gs_variable_array_operation_shr var var_data, var var_type, int var_len1, int var_len2, int var_len3, int var_len4
		;if ((len1 <= var_len1) || (len2 <= var_len2) || (len3 <= var_len3) || (len4 <= var_len4)) : return -2
		;if ((var_len1 < 0) || (var_len2 < 0) || (var_len3 < 0) || (var_len4 < 0)) : return -2
		error_check_ArrayIndex var_len1,var_len2,var_len3,var_len4
		;if (type != GSMD_VARIABLE_TYPE_INT) || (var_type != GSMD_VARIABLE_TYPE_INT) : return -4
		error_check_RequireType type,var_type, GSMD_VARIABLE_TYPE_INT
		data(var_len1,var_len2,var_len3,var_len4) >>= var_data
		return 0


//	dup

	#define	global gs_variable_dup(%1=0,%2)		_gs_variable_dup Gmd_Variable_Container@ModGS_Variable(%1), %2
	#modfunc _gs_variable_dup var p0
		dup p0, data
		return

	#define	global gs_variable_array_dup(%1=0,%2,%3=0,%4=0,%5=0,%6=0)		_gs_variable_array_dup Gmd_Variable_Container@ModGS_Variable(%1), %2, %3,%4,%5,%6
	#modfunc _gs_variable_array_dup var p0, int var_len1, int var_len2, int var_len3, int var_len4
		dup p0, data( var_len1, var_len2, var_len3, var_len4)
		return

#global


#module "ModGS_Variable"	//	Gmd_Variable_Container@ModGS_Variable

//	W[ϐ̖߂̓W[ϐw薳ŋLqł悤ɂĂ邯
//	̃W[ł͉ɂȂ̂ŏowLŋLqĂ
//	wL: _gs_variable_set_attrib Gmd_Variable_Container@ModGS_Variable(id), GSMD_VARIABLE_ATTRIB_SYSTEM
//	w薳:  gs_variable_set_attrib id, GSMD_VARIABLE_ATTRIB_SYSTEM

	#deffunc gs_variable_create_container
		dimtype Gmd_Variable_Container, 5, 1
		return

	#deffunc _gs_variable_clear int p_flag
		foreach Gmd_Variable_Container@ModGS_Variable
			if p_flag {
				if (_gs_variable_get_attrib(Gmd_Variable_Container@ModGS_Variable(cnt)) & GSMD_VARIABLE_ATTRIB_SYSTEM) : continue
				if _gs_variable_get_refcount(Gmd_Variable_Container@ModGS_Variable(cnt)) != 0 : continue
			}
			gs_define_delete _gs_variable_get_name(Gmd_Variable_Container@ModGS_Variable(cnt))
			delmod Gmd_Variable_Container@ModGS_Variable(cnt)
		loop
		return

	#deffunc gs_variable_init
		if vartype(Gmd_Variable_Container@ModGS_Variable) == 5 {
			_gs_variable_clear 0
			foreach Gmd_Variable_Container@ModGS_Variable
				delmod Gmd_Variable_Container@ModGS_Variable(cnt)
			loop
		} else {
			gs_variable_create_container
		}
		newmod Gmd_Variable_Container@ModGS_Variable, mod_gs_variable
		id = stat
		_gs_variable_construct Gmd_Variable_Container@ModGS_Variable(id), "", GSMD_VARIABLE_TYPE_NULL,0, 1,1,1,1
		_gs_variable_set_attrib Gmd_Variable_Container@ModGS_Variable(id), GSMD_VARIABLE_ATTRIB_SYSTEM
		return

#if GSMD_DEBUG

	#define	global ctype gs_variable_info_all(%1=3)		_gs_variable_info_all(%1)
	#defcfunc _gs_variable_info_all int p0
		sdim temp, 4096
		foreach Gmd_Variable_Container@ModGS_Variable
			if (gs_define_get_type(cnt) = GSMD_DEFINE_TYPE_SYSVAR) : if ((p0 & GSMD_INFO_VARLIST_SYSVAR) = 0) : continue
			if (gs_define_get_type(cnt) = GSMD_DEFINE_TYPE_VARIABLE) : if ((p0 & GSMD_INFO_VARLIST_USER) = 0) : continue
			temp += _gs_variable_info(Gmd_Variable_Container@ModGS_Variable(cnt))+"\n"
		loop
		return temp
	
	#defcfunc gs_variable_info int var_id
		if var_id < 0 : return ""
		if (varuse(Gmd_Variable_Container@ModGS_Variable(var_id)) != 1) : return ""
		return _gs_variable_info(Gmd_Variable_Container@ModGS_Variable(var_id))

	#define global ctype	gsc_info_Variable(%1)		gs_variable_info(%1)
	#define global ctype	gsc_info_VarList(%1=3)		gs_variable_info_all(%1)
	;#define global ctype	gsi_Variable(%1)		gs_variable_info(%1)
	;#define global ctype	gsi_VarList(%1=3)		gs_variable_info_all(%1)
#endif


	#defcfunc gs_variable_search str p0
		gs_define_searchf p0
		index = abs(stat)
		if (index) {
			if (gs_define_get_type(index) == GSMD_DEFINE_TYPE_VARIABLE) || (gs_define_get_type(index) == GSMD_DEFINE_TYPE_SYSVAR) {
				index = gs_define_get_value(index)
			} else {
				index = -1
			}
		} else {
			index = -1
		}
		return index

	#define	global gs_variable_create(%1,%2=GSMD_VARIABLE_TYPE_INT,%3=16,%4=1,%5=1,%6=1,%7=1)		_gs_variable_create %1,%2,%3,%4,%5,%6,%7
	#deffunc _gs_variable_create str var_name, int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		name = var_name // Ô
		if (gs_variable_search(name) != -1) : return
		newmod Gmd_Variable_Container@ModGS_Variable, mod_gs_variable
		id = stat
		_gs_variable_construct Gmd_Variable_Container@ModGS_Variable(id), name, var_type, var_size, var_len1, var_len2, var_len3, var_len4
		gs_define_add_variable var_name, id
		return id

	#define	global gs_variable_recreate(%1,%2=GSMD_VARIABLE_TYPE_INT,%3=16,%4=1,%5=1,%6=1,%7=1)		_gs_variable_recreate %1,%2,%3,%4,%5,%6,%7
	#deffunc _gs_variable_recreate str var_name, int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		name = var_name // Ô
		if (gs_variable_search(name) == -1) {
			newmod Gmd_Variable_Container@ModGS_Variable, mod_gs_variable
		}
		id = stat
		_gs_variable_construct Gmd_Variable_Container@ModGS_Variable(id), name, var_type, var_size, var_len1, var_len2, var_len3, var_len4
		gs_define_add_variable var_name, id
		return id

	#define	global gs_variable_recreateid(%1,%2=GSMD_VARIABLE_TYPE_INT,%3=16,%4=1,%5=1,%6=1,%7=1)		_gs_variable_recreateid %1,%2,%3,%4,%5,%6,%7
	#deffunc _gs_variable_recreateid int var_id, int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		if var_id < 0 : return -1
		if (varuse(Gmd_Variable_Container@ModGS_Variable(var_id)) != 1) : return -1
		id = var_id
		_gs_variable_reconstruct Gmd_Variable_Container@ModGS_Variable(id), var_type, var_size, var_len1, var_len2, var_len3, var_len4
		return id

	#define	global gs_variable_sysvar(%1,%2,%3=16,%4=1,%5=1,%6=1,%7=1)		_gs_variable_sysvar %1,%2,%3,%4,%5,%6,%7
	#deffunc _gs_variable_sysvar str var_name, int var_type, int var_size, int var_len1, int var_len2, int var_len3, int var_len4
		name = var_name // Ô
		if (gs_variable_search(name) != -1) : return
		newmod Gmd_Variable_Container@ModGS_Variable, mod_gs_variable
		id = stat
		_gs_variable_construct Gmd_Variable_Container@ModGS_Variable(id), name, var_type, var_size, var_len1, var_len2, var_len3, var_len4
		_gs_variable_set_attrib Gmd_Variable_Container@ModGS_Variable(id), GSMD_VARIABLE_ATTRIB_SYSTEM
		gs_define_add_sysvar var_name, id
		return id

	;#define	global gs_variable_delete(%1)		_gs_variable_delete %1
	#deffunc gs_variable_delete int var_id
		if var_id < 0 : return -1
		if (varuse(Gmd_Variable_Container@ModGS_Variable(var_id)) != 1) : return -1
		id = var_id
		
		if (_gs_variable_get_attrib(Gmd_Variable_Container@ModGS_Variable(id)) & GSMD_VARIABLE_ATTRIB_SYSTEM) : return -1
		if _gs_variable_get_refcount(Gmd_Variable_Container@ModGS_Variable(id)) != 0 : return -1

		gs_define_delete _gs_variable_get_name(Gmd_Variable_Container@ModGS_Variable(id))
		delmod Gmd_Variable_Container@ModGS_Variable(id)
		return id



	
//	ϐ\̗p̖

	#defcfunc gs_varstruct_read array var_struct
		if var_struct(1) {
			return gs_variable_get_array_value(var_struct, var_struct(2), var_struct(3), var_struct(4), var_struct(5))
		}
		return gs_variable_get_value(var_struct)

	#deffunc gs_varstruct_write array var_struct, var var_value
		type = gs_variable_get_type(var_struct)
		if var_struct(1) {
			if (type == GSMD_VARIABLE_TYPE_INT)		: gs_variable_array_write_int		var_struct,int(var_value),var_struct(2),var_struct(3),var_struct(4),var_struct(5) : return
			if (type == GSMD_VARIABLE_TYPE_DOUBLE)	: gs_variable_array_write_double	var_struct,double(var_value),var_struct(2),var_struct(3),var_struct(4),var_struct(5) : return
			if (type == GSMD_VARIABLE_TYPE_STR)		: gs_variable_array_write_str		var_struct,str(var_value),var_struct(2),var_struct(3),var_struct(4),var_struct(5) : return
			if (type == GSMD_VARIABLE_TYPE_LABEL)	: gs_variable_array_write_label		var_struct,int(var_value),var_struct(2),var_struct(3),var_struct(4),var_struct(5) : return
			return
		}
		if (type == GSMD_VARIABLE_TYPE_INT)		: gs_variable_write_int		var_struct, int(var_value) : return
		if (type == GSMD_VARIABLE_TYPE_DOUBLE)	: gs_variable_write_double	var_struct, double(var_value) : return
		if (type == GSMD_VARIABLE_TYPE_STR)		: gs_variable_write_str		var_struct, str(var_value) : return
		if (type == GSMD_VARIABLE_TYPE_LABEL)	: gs_variable_write_label	var_struct, int(var_value) : return
		return

	#deffunc gs_varstruct_dup var var_target, array var_struct
		if var_struct(1) {
			gs_variable_array_dup var_struct, var_target, var_struct(2), var_struct(3), var_struct(4), var_struct(5)
			return
		}
		gs_variable_dup var_struct, var_target
		return

//	̑

	#deffunc gs_variable_deleteByName str var_name
		id = gs_variable_search(var_name), 0
		if id == -1 : return -1
		gs_variable_delete id
		return

	#deffunc gs_variable_dupFromName var var_target, str var_name
		id = gs_variable_search(var_name), 0
		if id == -1 : return -1
		gs_variable_dup id, var_target
		return 0

	#defcfunc gs_variable_readFromName str var_name, int var_len1, int var_len2, int var_len3, int var_len4
		id = gs_variable_search(var_name), 0
		if id == -1 : return 0
		return gs_variable_get_array_value(id, var_len1, var_len2, var_len3, var_len4)

	#deffunc gs_variable_writeByName var var_value, str var_name, int var_len1, int var_len2, int var_len3, int var_len4
		id = gs_variable_search(var_name), 0
		if id == -1 : return -1
		if (var_len1!=0) || (var_len2!=0) || (var_len3!=0) || (var_len4!=0) {
			id(1) = 4, var_len1, var_len2, var_len3, var_len4
		}
		gs_varstruct_write id, var_value
		return 0
	
#global

gs_variable_init



#define	global ctype	gsv_Read(%1)			gs_varstruct_read(%1)
#define	global			gsv_Write(%1,%2)		_temp@ModGS_Temp=%2:gs_varstruct_write %1,_temp@ModGS_Temp
#define	global			gsv_Dup(%1,%2)			gs_varstruct_dup %1,%2
#define global ctype	gsv_GetType(%1=0)		gs_variable_get_type(%1)
#define global ctype	gsv_GetName(%1=0)		gs_variable_get_name(%1)
#define global ctype	gsv_GetLen1(%1=0)		gs_variable_get_len1(%1)
#define global ctype	gsv_GetLen2(%1=0)		gs_variable_get_len2(%1)
#define global ctype	gsv_GetLen3(%1=0)		gs_variable_get_len3(%1)
#define global ctype	gsv_GetLen4(%1=0)		gs_variable_get_len4(%1)

#define	global ctype	gsc_variable_Read(%1,%2=0,%3=0,%4=0,%5=0)	gs_variable_readFromName(%1,%2,%3,%4,%5)
#define	global ctype	gsc_Var(%1,%2=0,%3=0,%4=0,%5=0)				gsc_variable_read(%1,%2,%3,%4,%5)

#define	global 			gsc_variable_Write(%1,%2,%3=0,%4=0,%5=0,%6=0)									_temp@ModGS_Temp=%1:gs_variable_writeByName _temp@ModGS_Temp,%2,%3,%4,%5,%6
#define	global			gsc_variable_Dup(%1,%2)															gs_variable_dupFromName %1,%2
#define	global			gsc_variable_Create(%1,%2=GSMD_VARIABLE_TYPE_INT,%3=16,%4=1,%5=1,%6=1,%7=1)		gs_variable_create %1,%2,%3,%4,%5,%6,%7
#define	global			gsc_variable_Recreate(%1,%2=GSMD_VARIABLE_TYPE_INT,%3=16,%4=1,%5=1,%6=1,%7=1)	gs_variable_recreate %1,%2,%3,%4,%5,%6,%7		
#define	global			gsc_variable_Clear																_gs_variable_clear 1
#define	global			gsc_variable_Delete(%1)															gs_variable_deleteByName %1

#define global ctype	gsc_variable_GetId(%1)			gs_variable_search(%1)
#define global ctype	gsc_VarId(%1)					gs_variable_search(%1)




#endif
